# Contributing guidelines
Welcome to [EEGraph](https://github.com/ufvceiec/EEGRAPH)! First of all, thank you for taking the time to contribute and make this project better! Make sure that you read the whole **Contribution guidelines** before sending your pull requests. 

## Contribution to this repository
You can contribute to EEGraph in many ways:

* Suggesting a feature. 
* Filing a bug report. 
* Improving the documentation. 
* Improving comments.
* Writing proper tests. 
* Submitting a pull request. 


### :scroll: Licensing 
When you sumbit your code to EEGraph, you implicitly agree to adopt the associated licenses. Your work will be distributed under [GPL-3.0 License](https://github.com/ufvceiec/EEGRAPH/blob/develop-refactor/LICENSE) once your pull request is merged. 

## :bulb: Suggesting a feature 
If you have a good idea for a feature please let us know! From improvements for already existing functionalities to completely new features. 

Make sure to:
* Check if there is a newer version which already provides this feature. 
* Check if the feature has already been suggested in the [issues](https://github.com/ufvceiec/EEGRAPH/issues) (Open or closed) section. If it exists, please add a comment to the existing issue instead of opening a new one.
* Use the `enhancement` issue [label](https://github.com/ufvceiec/EEGRAPH/labels).  
* Consider if its necessary in the library.

## :beetle: Filing a bug report 
If you find some sort of bug, problem or something that should be updated. Please first search the open [issues](https://github.com/ufvceiec/EEGRAPH/issues) to see if someone has already reported the issue.

If its something new, please file a bug report on the repository [issue](https://github.com/ufvceiec/EEGRAPH/issues) section to let us know. Be as detailed as posible, and be ready to give us some feedback if needed. Make sure to:

* Tell us where is the problem. As detailed as possible.
* Provide the usage example, so we can replicate the problem.
* Use the `bug` issue [label](https://github.com/ufvceiec/EEGRAPH/labels).
* Be ready to provide feedback if needed. 

## :orange_book: Improving documentation
The documentation for EEGraph can be founde [here](https://github.com/ufvceiec/EEGRAPH/wiki). Clear and complete documentation is key for users to understand the library and the code. Please dont hesitate to submit any feedback to improve it, recomendations, single-letter typos, errors, extensions. Anything that improves the documentation for all future users is welcomed.  

Documentation related issues should be tagged with the `documentation` issue [label](https://github.com/ufvceiec/EEGRAPH/labels).

## :hammer_and_wrench: Submitting a pull request 
**All New implementations** are welcome! New solutions for any problem. New frequency and time-frequency domain connectivity measures to modelate EEGs as graphs. Extensions of EEGraph current functionalities. Working on suggested features listed [here](https://github.com/ufvceiec/EEGRAPH/labels/enhancement%20%3Abulb%3A). Fixing reported bugs listed [here](https://github.com/ufvceiec/EEGRAPH/labels/bug%20%3Abeetle%3A). 

Please check wheter the solution is already implemented or not before sumbitting your pull request. If the change you want to introduce will require a significant amount of work to write, it is recommended to open an [issue](https://github.com/ufvceiec/EEGRAPH/issues) stating what you want to do. In this way you can have a conversation with other contributors that might help you have a better idea. 

Make sure:
- The file extension for code files shoud be `.py`. 
- Avoid using external libraries for basic algorithms. 
- If a new library is used that is not listed in the [requirements](https://github.com/ufvceiec/EEGRAPH/blob/develop-refactor/requirements.txt), make sure to add it for your submission. 
- You should try to write tests that ensure the provided code works as expected. 
- Add or change the [documentation](https://github.com/ufvceiec/EEGRAPH/wiki) as needed. 
- Make sure the pull request is done to the project´s `develop` branch.



### :trophy: Your PR is merged! 
Congratulations! The EEGraph team and the whole Python community thanks you.

You will be listed as a contributor in the [repository contributors](https://github.com/ufvceiec/EEGRAPH/graphs/contributors).
